<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Different Approaches</TITLE>
<link href="builder_16.html" rel=Next>
<link href="builder_14.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_14.html">previous</A>, <A HREF="builder_16.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC34" HREF="builder_toc.html#TOC34">Different Approaches to Creating Expression Trees</A></H2>
<P>
<A NAME="IDX106"></A>
<A NAME="IDX107"></A>
There are many ways to create expressions.

</P>


<H3><A NAME="SEC35" HREF="builder_toc.html#TOC35">Using the Parser of the C++ Compiler.</A></H3>
<P>
The C++ compiler's parser can be used to create expression trees.  This
is accomplished in the builder by overloading all the operators for the
builder class (the only exception is the <EM>*</EM> operator).  This is an
elegant and simple way to express the SUIF structures to be
created.  Since the C++ compiler performs the parsing at compile time,
this method is efficient.  C++ compiler will also perform some amount of
semantic and type checking.  But, since all the operators are
overloaded, there can be some subtle bugs (or features in many cases).
For example, assigning a builder structure to another structure is not
as simple as <CODE> a = b</CODE>.  Since <CODE>a</CODE> and <CODE>b</CODE> are
<CODE>block</CODE> types and the assign operator is overloaded, the above
statement generates a new block that will generate a SUIF structure
with an assignment in it!  See section <A HREF="builder_32.html#SEC63">Constructing Expressions Using Operator Overloading</A> for a
full description of operators overloaded in the builder.

</P>


<H3><A NAME="SEC36" HREF="builder_toc.html#TOC36">Using Builder Functions and Operator Symbols</A></H3>
<P>
The builder function <CODE>op()</CODE> can be used to construct expression
trees. For example <CODE>block::op(a, "+", b)</CODE> will generate an add
instruction. See section <A HREF="builder_33.html#SEC64">Constructing Expressions Using Explicit Function Calls</A> for a full list of
builder functions available.

</P>


<H3><A NAME="SEC37" HREF="builder_toc.html#TOC37">Using Builder Functions and the Builder's Operator Enumerations</A></H3>
<P>
All the unary, binary and assignment operators that can be used have a
corresponding enumerated type in the builder. These enumerated types can
be used when creating an expression. See section <A HREF="builder_34.html#SEC65">Operators</A> for a list
of these enumerated types.

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_14.html">previous</A>, <A HREF="builder_16.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
